
/*******************************************************************
 $CRT 09 Jan 1997 : hb

 $AUT Holger Burkarth
 $DAT >>TDChgDsk.c<<   09 Jan 1997    16:31:12 - (C) ProDAD
*******************************************************************/

//##ex mcpp:cppc -gs -o pos:pos/Ex/TDChgDsk p:pLib/StartCode.o p:/pOS_RKRM/pTrackdisk/TDChgDsk.c p:pLib/StdIO.o -l pOSStub -l pOS

/***********************************************************
  pOS programing example - Copyright (C) 1995-97 proDAD

  This code was written as an easy to understand example,
  how to program pOS features. It is provided 'as-is',
  without any express or implied warranty.

  Permission is hereby granted to use, copy and modify
  this source code for any purpose, without fee, subject
  to the following conditions:

    (1) This notice may not be removed or altered from any
        source distribution.

    (2) Altered source versions must be plainly marked as
        such, and must not be misrepresented as being
        the original source code.

    (3) If only executable code is distributed, then the
        accompanying documentation have to state that
        "this software is based in part on examples of
        the pOS developer packet".

    (4) Permission for use of this code is granted only
        if the user accepts full responsibility for any
        undesirable consequences. proDAD accept NO LIABILITY
        for damages of any kind.

  proDAD
***********************************************************/

/*\
*** Example:
***
\*/


#define __COMPUTER_AMIGA 1
#define NOMYDEBUG

#include "p:pExec/Types.h"
#include "p:pExec/MsgPort.h"
#include "p:pExec/Interupt.h"
#include "p:pExec/Node.h"
#include "p:pDOS/ArgTags.h"
#include "p:pDOS/DosSig.h"
#include "p:pDOS/DosErrors.h"
#include "p:Device/Trackdisk.h"

#include "p:proto/pLibExt.h"
#include "p:proto/pExec2.h"
#include "p:proto/pDOS2.h"

#ifdef _____ME_____
  #include "grund/inc_string.h"
  #include "grund/inc_stdio.h"
#else
 #ifdef __cplusplus
 extern "C" {
 #endif
  #include <string.h>
  #include <stdio.h>
 #ifdef __cplusplus
 }
 #endif
#endif


const CHAR *HelpText=
""
;

const CHAR *PrgHeader=
"";

const CHAR *PrgVerText=
"$VER: 1.0 ("__DATE2__") (Copyright 1996-97 by proDAD) (Created by Holger Burkarth)";





/*----------------------------------
-----------------------------------*/
ULONG Inter_func(_R_A0 const pOS_Interrupt* inter,_R_A1 APTR)
{
  pOS_SendSignal((struct pOS_Task*)inter->is_UserData[0],DOSSIGF_CTRL_F);

  return(FALSE); // *** folgende Interrupts ausfrufen
}




/*----------------------------------
-----------------------------------*/
#ifdef __cplusplus
extern "C"
#endif

VOID main()
{
  struct pOS_DosArgs* Args;
  UWORD Err=0;
  ULONG Ops[1]={0};

  Args=pOS_ReadDosArgs(
//
"UNIT/N",
Ops,sizeof(Ops)/sizeof(ULONG),

    ARGTAG_PrgHeaderText, (ULONG)PrgHeader,    /* kurze Programm-Beschreibung */
    ARGTAG_HelpText,      (ULONG)HelpText,     /* Help-Texte */
    ARGTAG_PrgVerText,    (ULONG)PrgVerText,   /* VER-String */
    TAG_END);

  if(Args) {
    pOS_MsgPort Port;
    pOS_TrackdiskIO *IO;

    if(pOS_ConstructMsgPort(&Port)) {
      if(IO=(pOS_TrackdiskIO*)pOS_CreateIORequest(&Port,sizeof(pOS_TrackdiskIO))) {
        pOS_OpenDevice("pTrackdisk.device",Ops[0] ? *((ULONG*)Ops[0]):0,
                       (pOS_IORequest*)IO,0,0);
        if(IO->tdio_Error==0) {
          pOS_Interrupt Inter;

          Inter.is_Node.ln_Succ=NULL;
          Inter.is_Node.ln_Pred=NULL;
          Inter.is_Node.ln_Type=NTYP_INTERRUPT;
          Inter.is_Node.ln_Name="Disk-Change-Test";
          Inter.is_Node.ln_Pri=0;
          Inter.is_Code=Inter_func;
          Inter.is_UserData[0]=(ULONG)pOS_FindTask(0);

          IO->tdio_Command=TDCMD_AddChangeInt;
          IO->tdio_Data    =&Inter;
          IO->tdio_Length  =sizeof(Inter);
          pOS_DoIO((pOS_IORequest*)IO);
          if(IO->tdio_Error==0) {
            ULONG Sigs;

            printf("Disk-Change Handler installed. (Ctrl-C for abort)\n");
            do {
              Sigs=pOS_WaitSignal(DOSSIGF_CTRL_C | DOSSIGF_CTRL_F);
              if(Sigs & DOSSIGF_CTRL_F) {
                printf("Disk-Change\n");
              }
            } while( !(Sigs & DOSSIGF_CTRL_C));

            IO->tdio_Command=TDCMD_RemChangeInt;
            IO->tdio_Data    =&Inter;
            IO->tdio_Length  =sizeof(Inter);
            pOS_DoIO((pOS_IORequest*)IO);
          }
          else printf("TDCMD_AddChangeInt failed, error=%ld\n",IO->tdio_Error);

          pOS_CloseDevice((pOS_IORequest*)IO);
        }
        else printf("pOS_OpenDevice failed, error=%ld\n",IO->tdio_Error);
        pOS_DeleteIORequest((pOS_IORequest*)IO);
      }
      else printf("pOS_CreateIORequest failed\n");
      pOS_DestructMsgPort(&Port);
    }
    else printf("pOS_ConstructMsgPort failed\n");

    pOS_DeleteDosArgs(Args);  /* Args freigeben */
  }
  else Err=DOSFAIL_FAIL;  /* vollkommen fehlgeschlagen */

  pOS_SetShellFail(Err);
}
